#ifndef SSL_H
#define SSL_H

#include <openssl/ossl_typ.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <stdlib.h>

#include "config.h"

typedef struct CertList CertList;
struct CertList {
	char *host;
	EVP_PKEY *key;
	X509 *cert;
	CertList *next;
};

SSL_CTX* InitServerCTX(Config *config);

EVP_PKEY* generate_ca_key();
X509* generate_ca_cert(EVP_PKEY * pkey);
X509* generate_site_cert( EVP_PKEY *pkey, X509 *caCert, char *host );
bool create_and_save_key(char keyfile[]);
bool create_and_save_cert(char keyfile[], EVP_PKEY *pkey);
EVP_PKEY* read_private_key(char keyfile[]);

CertList *newCertListItem(char *host, EVP_PKEY *key, X509 *cert);
CertList *getLastCertListItem(CertList *item);
unsigned int countCertListItems(CertList *item);
CertList *findCertListItem( CertList *first, char *hostname );

#endif /* ifndef SSL_ */
